/*-----------------------------------------------------------------------

File  : scanner.h

Author: Stephan Schulz

Contents
 
  Declarations for use with a simple scanner for PL

  Copyright 2002 by the author.
  This code is released under the GNU General Public Licence.
  See the file COPYING.

Changes

<1> Wed Sep 11 01:10:05 CEST 2002
    New

-----------------------------------------------------------------------*/

#ifndef SCANNER

#define SCANNER

#include "source_handler.h"
#include <ctype.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/

#define MAXLITLEN 80

typedef enum 
{
   NoToken,
   NullDigit,
   Semicolon,
   Colon,
   IncOp,
   AssignOp,
   ResWordLoop,
   ResWordEndloop,
   ResWordGoto,
   Variable,
   Label
}TokenType;

typedef struct
{
   TokenType type;
   char      spelling[MAXLITLEN];
   int       line;
   int       column;
}Token;


void  SkipSpace(void);
Token NextToken(void);
void  PrintToken(Token tok);


/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/


#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/








